#ifndef LIBWCCL_VALUES_POSITIONREF_H
#define LIBWCCL_VALUES_POSITIONREF_H

#include <libwccl/values/position.h>
#include <boost/make_shared.hpp>

namespace Wccl {

class PositionRef : public Value
{
public:
	WCCL_VALUE_PREAMBLE

	explicit PositionRef(const boost::shared_ptr<Position>& base,
			int offset = 0)
		: base_(base), offset_(offset)
	{
		assert(base_);
	}

	explicit PositionRef(int base, int offset = 0)
		: base_(boost::make_shared<Position>(base)), offset_(offset)
	{
	}

	std::string to_raw_string() const;

	const boost::shared_ptr<Position>& get_base() const {
		return base_;
	}

	int get_offset() const {
		return offset_;
	}

	void set_offset(int offset) {
		offset_ = offset;
	}

private:
	boost::shared_ptr<Position> base_;

	int offset_;
};

} /* end ns Wccl */

#endif // LIBWCCL_VALUES_POSITIONREF_H
